import React, { useContext, useState } from "react";
import { userContext, IconMenuButton } from "@ess-ics/ce-ui-common";
import { CreateIOC } from "../../../components/IOC/CreateIOC";
import { SimpleModal } from "../../../components/common/SimpleModal/SimpleModal";
import { useCreateIOC } from "../../../api/SwaggerApi";

export function CreateIOCButton() {
  const { user } = useContext(userContext);
  const [iocFormOpen, setIOCFormOpen] = useState(false);

  const iconMenuButtonProps = {
    menuItems: [
      {
        text: "New IOC",
        action: () => setIOCFormOpen(true)
      }
    ]
  };

  const closeModal = () => {
    setIOCFormOpen(false);
  };

  return user ? (
    <>
      <IconMenuButton {...iconMenuButtonProps} />
      <SimpleModal
        open={iocFormOpen}
        setOpen={setIOCFormOpen}
      >
        <CreateIOC
          open={iocFormOpen}
          setOpen={setIOCFormOpen}
          isUpdateIoc={false}
          submitCallback={closeModal}
          hook={useCreateIOC}
          title="Create new IOC"
          buttonText="Create"
        />
      </SimpleModal>
    </>
  ) : null;
}
